{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit AllMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    HideButton: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure StartButtonsClick(Sender: TObject);
    procedure HideButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses DemoExec, DemoHelp, DemConst;

procedure TForm1.FormCreate(Sender: TObject);
const
  BitmapHeight = 48;
var
  Bitmap: TBitmap;
  Button: TSpeedButton;
  I: Integer;
begin
  InitHelp;
  Bitmap := TBitmap.Create;
  try
    with Bitmap do
    begin
      Height := BitmapHeight;
      Width := BitmapHeight;
      for I := 0 to Panel1.ControlCount - 1 do
      begin
        Button := TSpeedButton(Panel1.Controls[I]);
        with Button do
        begin
          { Gre der Bitmaps verdoppeln }
          Canvas.StretchDraw(Rect(0, 0, BitmapHeight, BitmapHeight), Glyph);
          Glyph := Bitmap;
          { Kurzhilfe zuweisen }
          Hint := LoadStr(AllDemos[I] + 2);
        end;
      end;
    end;
  finally
    Bitmap.Free;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked then FormStyle := fsStayOnTop
  else FormStyle := fsNormal;
end;

procedure TForm1.StartButtonsClick(Sender: TObject);
var
  I: Integer;
begin
  with Sender as TSpeedButton do
  begin
    if Tag = 0 then
    begin
      I := StrToInt(Name[Length(ClassName)]) - 1;
      Tag := Longint(MakeDemoExecInfo(AllDemos[I], AllDemos[I] + 1,
        AllDemos[I] + 2));
      { Programm nicht gefunden }
      if PDemoExecInfo(Tag)^.Path[0] = #0 then Exit;
    end;
    BlcDemoExec(PDemoExecInfo(Tag));
  end;
end;

procedure TForm1.HideButtonClick(Sender: TObject);
var
  I: Integer;
begin
  with Panel1 do
    for I := 0 to ControlCount - 1 do
      with Controls[I] do
        if Tag <> 0 then ShowBlcDemo(FindBlcDemo(PDemoExecInfo(Tag)), False);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
  MsgResult: TModalResult;
begin
  if Action = caNone then Exit;
  with Panel1 do
  begin
    I := 0;
    while (I < DemoCount) and (FindBlcDemo(PDemoExecInfo(Controls[i].Tag)) = 0) do Inc(I);
    { Bei Bedarf alle Demos beenden }
    if not (I = DemoCount) then
    begin
      MsgResult := (MessageDlg(LoadStr(SAllDemoFree), mtConfirmation, mbYesNoCancel, 0));
      case MsgResult of
        mrCancel: Action := caNone;
        mrYes: for I := 0 to ControlCount - 1 do with Controls[I] do
          if Tag <> 0 then DestroyBlcDemo(PDemoExecInfo(Tag));
      end;
    end;
  end;
end;

end.


