{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit MultMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Multcomb, ExtCtrls;

type
  TForm1 = class(TForm)
    MultiComboBox1: TMultiComboBox;
    MultiComboBox2: TMultiComboBox;
    MultiComboBox3: TMultiComboBox;
    MultiComboBox4: TMultiComboBox;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure MultiComboBoxenDropDown(Sender: TObject);
    procedure MultiComboBoxenCloseUp(Sender: TObject);
    procedure MultiComboBoxenDialog(Sender: TObject);
    procedure MultiComboBoxenGetMultiSelText(Sender: TObject;
      ASelCount: Integer; var MultiSelText: OpenString);
    procedure CheckBoxenClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   published

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses EventInf, DemoHelp, DemConst;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitHelp;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeHelp;
end;

procedure TForm1.MultiComboBoxenDropDown(Sender: TObject);
begin
  if CheckBox1.Checked then ShowEventInfo(Sender, 'MultiComboBoxenDropDown',
   SOnDropDownParam, SOnDropDownInfo, SPerCheckbox);
end;

procedure TForm1.MultiComboBoxenCloseUp(Sender: TObject);
begin
  if CheckBox2.Checked then ShowEventInfo(Sender, 'MultiComboBoxenCloseUp',
   SOnCloseUpParam, SOnCloseUpInfo, SPerCheckbox);
end;

procedure TForm1.MultiComboBoxenDialog(Sender: TObject);
begin
  if CheckBox3.Checked then ShowEventInfo(Sender, 'MultiComboBoxenDialog',
   SOnDialogParam, SOnDialogInfo, SPerCheckbox);
end;

procedure TForm1.MultiComboBoxenGetMultiSelText(Sender: TObject;
  ASelCount: Integer; var MultiSelText: OpenString);
begin
   if CheckBox4.Checked then
   begin
     ShowEventInfo(Sender, 'MultiComboGetMultiSelText',
     SOnGetMultiSelTextParam, SOnGetMultiSelTextInfo, SPerCheckbox);
     if ASelCount > 0 then MultiSelText := IntToStr(ASelCount) + ' Eintrge';
   end;
end;

procedure TForm1.CheckBoxenClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ControlCount -1 do
    if Controls[I] is TMultiComboBox then
      if Sender = Checkbox5 then
        TMultiComboBox(Controls[I]).ExtendedSelect := Checkbox5.Checked
      else TMultiComboBox(Controls[I]).MultiSelect := Checkbox6.Checked;
end;

{ Hilfe fr die gezeigten Ereignisse und Eigenschaften }
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const
  EventPfx = 'Ereignis ';
  PropPfx = 'Eigenschaft ';
var
  I: Integer;
  S: String;
begin
  if (ActiveControl is TCheckBox) and  (Key = VK_F1) and (Shift = []) then
    with TCheckBox(ActiveControl) do
    begin
      S := Caption;
      if Tag = 0 then Delete(S, 1 , Length(EventPfx))
      else Delete(S, 1 , Length(PropPfx));
      ShowDemoHelp(S, TMultiComboBox, True, Tag = 0, (Tag = 0) and
        (S <> 'OnGetMultiSelText'));
      Key := 0;
    end;
end;

end.


