{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit ObInProp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Multcomb, ExtCtrls, Spin;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CompListButton: TSpeedButton;
    CreateButton: TSpeedButton;
    DestroyButton: TSpeedButton;
    PropFilterButton: TSpeedButton;
    PropStrFilterButton: TSpeedButton;
    RestoreButton: TSpeedButton;
    FormBox: TMultiComboBox;
    ClassBox: TMultiComboBox;
    ComponentBox: TMultiComboBox;
    ShortCutBox: TMultiComboBox;
    ActControlCheck: TCheckBox;
    ActFormCheck: TCheckBox;
    ShowEvents: TCheckBox;
    RefreshEdit: TSpinEdit;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    procedure ActControlCheckClick(Sender: TObject);
    procedure ActFormCheckClick(Sender: TObject);
    procedure CompListButtonClick(Sender: TObject);
    procedure CreateButtonClick(Sender: TObject);
    procedure DestroyButtonClick(Sender: TObject);
    procedure PropFilterButtonClick(Sender: TObject);
    procedure PropStrFilterButtonClick(Sender: TObject);
    procedure RestoreButtonClick(Sender: TObject);
    procedure ComponentBoxDropDown(Sender: TObject);
    procedure ComponentBoxGetMultiSelText(Sender: TObject;
      ASelCount: Integer; var MultiSelText: OpenString);
    procedure FormBoxDropDown(Sender: TObject);
    procedure FormBoxCloseUp(Sender: TObject);
    procedure RefreshEditKeyPress(Sender: TObject; var Key: Char);
    procedure RefreshEditChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
     procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShortCutBoxCloseUp(Sender: TObject);
    procedure ShowEventsClick(Sender: TObject);
  private
    FDestroyComponents: Boolean;
    procedure FillShortCutBox;
    procedure UpdateAll;
    procedure UpdateFormBox;
    procedure UpdateComponentBox;
  public
    procedure InspectorChanged;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses ObInMain, Menus, DsgnIntf, TypInfo, PropInfo, PrpCtrls, DDlgForm,
  ScreenCt, EventDum, BlcUtils, DemoHelp, DemConst;

procedure TForm2.FormBoxDropDown(Sender: TObject);
begin
  UpdateFormBox;
end;

procedure TForm2.FormBoxCloseUp(Sender: TObject);
begin
  with FormBox do
    if ItemIndex <> -1 then Inspector.Form := TForm(Items.Objects[ItemIndex])
    else Inspector.Form := nil;
end;

procedure TForm2.ShortCutBoxCloseUp(Sender: TObject);
begin
  with ShortCutBox do
   if ItemIndex <> -1 then Inspector.ShortCut := TextToShortCut(Text);
end;

procedure TForm2.RefreshEditKeyPress(Sender: TObject; var Key: Char);
begin
  { Bug in TSpinEdit. TSpinEdit akzeptiert nicht nur -12, sondern
    auch --12, -1-2-3 usw. }
  if Key = '-' then Key := #0;
end;

procedure TForm2.RefreshEditChange(Sender: TObject);
begin
  if RefreshEdit.Text <> '' then
    Inspector.RefreshInterval := StrToInt(RefreshEdit.Text);
end;

procedure TForm2.ActControlCheckClick(Sender: TObject);
begin
  Inspector.ActiveControlDetected := ActControlCheck.Checked;
end;

procedure TForm2.ActFormCheckClick(Sender: TObject);
begin
  Inspector.ActiveFormDetected := ActFormCheck.Checked;
end;

procedure TForm2.ShowEventsClick(Sender: TObject);
begin
  EventDummy.Show := ShowEvents.Checked;
end;

procedure TForm2.CreateButtonClick(Sender: TObject);
begin
  with ClassBox do ScreenCt.CreateNew(Inspector.Form,
    TControlClass(Items.Objects[ItemIndex]));
end;

{ Zerstren der ausgewhlten Komponenten }
procedure TForm2.DestroyButtonClick(Sender: TObject);
var
  I: Integer;
  IsForm: Boolean;
begin
  with ComponentBox, Items do
    try
      { Aktualisieren der Anzeigen verhindern }
      FDestroyComponents := True;
      for I := Count -1 downto 0 do
        if Selected[I] then
        begin
          IsForm := Objects[I] is TForm;
          Objects[I].Free;
          if IsForm then Break;
        end;
    finally
      FDestroyComponents := False;
      { Falls das Hauptformular zerstrt wurde, so wird das Programm beendet }
      if Application.MainForm = nil then Application.Terminate
      else UpdateAll;
    end;
end;

procedure TForm2.ComponentBoxDropDown(Sender: TObject);
begin
  UpdateComponentBox;
end;

procedure TForm2.ComponentBoxGetMultiSelText(Sender: TObject;
  ASelCount: Integer; var MultiSelText: OpenString);
begin
  if ASelCount > 0 then MultiSelText := IntToStr(ASelCount) + ' ' +
    LoadStr(SComponents);
end;

procedure TForm2.RestoreButtonClick(Sender: TObject);
var
  I: Integer;
begin
  Form1.RestoreInspector;
  for I := 0 to ControlCount -1 do
    if Controls[I].Tag <> -1 then Controls[I].Enabled := True
    else Controls[I].Visible := False;
  ShowEvents.Visible := True;
end;

{ Formular nur bei Programmende schlieen }
procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  UpdateAll;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  with ClassBox, Items do
  begin
    AddObject('Label', Pointer(TLabel));
    AddObject('Edit', Pointer(TEdit));
    AddObject('Memo', Pointer(TMemo));
    AddObject('CheckBox', Pointer(TCheckBox));
    AddObject('RadioButton', Pointer(TRadioButton));
    AddObject('ComboBox', Pointer(TComboBox));
    AddObject('Panel', Pointer(TPanel));
    AddObject('SpeedButton', Pointer(TSpeedButton));
    AddObject('Form', Pointer(TForm));
    ItemIndex := IndexOf('Form');
  end;
  FillShortCutBox;
end;

{ Hilfe fr die Eigenschaften }
procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Control: TWinControl;
  S: String;
begin
  if (Key = VK_F1) and (Shift = []) then
  begin
    Control := ActiveControl;
    if Control is TCheckBox then S := TCheckBox(Control).Caption
    else S := Control.Hint;
    if S <> '' then ShowDemoHelp(S, TRtObjectInspector, True, False, False);
    Key := 0;
  end;
end;

{ Wird von der Ereignisbehandlungsrotine RtObjectInspector1Change
  des Hauptformulares aufgerufen }
procedure TForm2.InspectorChanged;
var
  I: Integer;
begin
  if Inspector <> nil then
    case Inspector.State of
      isDestroying:
       begin
         for I := 0 to ControlCount -1 do
           if Controls[I].Tag <> -1 then Controls[I].Enabled := False
           else Controls[I].Visible := True;
         ShowEvents.Visible := False;
       end;
      isEndAddProp, isEndDeleteProp: UpdateAll;
    end;
end;

procedure TForm2.UpdateAll;
begin
  if (Inspector <> nil) and not FDestroyComponents then
    with Inspector do
    begin
      ActControlCheck.Checked := ActiveControlDetected;
      ActFormCheck.Checked := ActiveFormDetected;
      RefreshEdit.Text := IntToStr(RefreshInterval);
      ShortCutBox.Text := ShortCutToText(ShortCut);
      UpdateComponentBox;
      UpdateFormBox;
    end;
end;

{ Dialog um die Eigenschaft PropertyFilter des RtObjectInspectors zu ndern }
procedure TForm2.PropFilterButtonClick(Sender: TObject);
var
  Dialog: TDualDialogForm;
begin
  Application.CreateForm(TDualDialogForm, Dialog);
  with Dialog, DualList, Inspector do
    try
      Caption := LoadStr(SDlgPfCaption);
      SourceCaption := LoadStr(SDlgPfSourceCaption);
      DestinationCaption := LoadStr(SDlgPfDestinationCaption);
      SynchronButton := False;
      HelpStr := TSpeedButton(Sender).Hint;
      DestinationItems := TypeKindsToStrings(PropertyFilter);
      SourceItems := TypeKindsToStrings(tkAny - PropertyFilter);
      if ShowModal = idOK then
        PropertyFilter := StringsToTypeKinds(DestinationItems);
    finally
      Dialog.Free;
    end;
end;

{ Dialog um die Eigenschaft PropertyStringFilter des RtObjectInspectors zu ndern }
procedure TForm2.PropStrFilterButtonClick(Sender: TObject);
const
  BspFilter: array[0..19] of String = (
    '*', '*.*', 'A*', 'B*', 'E*', 'M*', 'S*', 'W*', '*e', '*t', '*n',
    'Client*', 'Font*', 'H?ight', 'OnKey*', 'OnMouse*', 'On?????',
    'T??', 'Wi?d?h', 'VertScrollBar*');
var
  Dialog: TDualDialogForm;
begin
  Application.CreateForm(TDualDialogForm, Dialog);
  with Dialog, DualList, Inspector do
    try
      Caption := LoadStr(SDlgPsfCaption);
      SourceCaption := LoadStr(SDlgPsfSourceCaption);
      DestinationCaption := LoadStr(SDlgPsfDestinationCaption);
      Synchron := True;
      HelpStr := TSpeedButton(Sender).Hint;
      DestinationItems := PropertyStringFilter.Items;
      AssignStrings(SourceItems, SubtractStrings(MakeStrings(BspFilter, False),
        PropertyStringFilter.Items, True, False), True);
      if ShowModal = idOK then
        PropertyStringFilter.Items := DestinationItems;
    finally
      Dialog.Free;
    end;
end;

{ Dialog um die Eigenschaft ComponentList des RtObjectInspectors zu ndern }
procedure TForm2.CompListButtonClick(Sender: TObject);
var
  Dialog: TDualDialogForm;
  NewList: TComponentList;
  I: Integer;
begin
  Application.CreateForm(TDualDialogForm, Dialog);
  with Dialog, DualList, Inspector do
    try
      Caption := LoadStr(SDlgCoCaption);
      SourceCaption := LoadStr(SDlgCoSourceCaption);
      DestinationCaption := LoadStr(SDlgCoDestinationCaption);
      Synchron := True;
      HelpStr := TSpeedButton(Sender).Hint;
      DestinationItems := SelComponents;
      AssignStrings(SourceItems, SubtractStrings(FormComponents,
        SelComponents, False, False), True);
      if ShowModal = idOK then
      begin
        NewList := TComponentList.Create;
        for I := 0 to DestinationItems.Count -1 do
          NewList.Add(TComponent(DestinationItems.Objects[I]));
        ComponentList := NewList;
      end;
    finally
      Dialog.Free;
    end;
end;

{ Aktualiseren der ComboBox mit den Formularen }
procedure TForm2.UpdateFormBox;
var
  I: Integer;
  Form: TForm;
begin
  with FormBox, Items do
  begin
    Clear;
    for I := 0 to Screen.FormCount - 1 do
    begin
      Form := Screen.Forms[I];
      if (Form <> self) and (Form.Owner <> Inspector) then
        AddObject(GetObjectName(Form), Form);
    end;
    ItemIndex := IndexOfObject(Inspector.Form);
  end;
end;

{ ComboBox mit den Komponenten aktualiseren.
  Mglich wre auch die Zuweisung ComponentBox.Items := Inspector.FormComponents.
  Allerdings wrde dann die Selektion der einzelnen Eintrge verloren gehen. }
procedure TForm2.UpdateComponentBox;
var
  I: Integer;
  AllComponents: TStrings;
begin
  with Inspector, ComponentBox, Items do
  begin
    AllComponents := FormComponents;
    { Lschen von zerstrten Komponenten }
    for I := Count - 1 downto 0 do
      if AllComponents.IndexOfObject(Objects[I]) = -1 then Delete(I);
    { Hinzufgen von neuen Komponenten }
    for I := 0 to AllComponents.Count -1 do
      if IndexOfObject(AllComponents.Objects[I]) = -1 then
        AddObject(AllComponents[I], AllComponents.Objects[I]);
    { Falls kein Eintrag mehr selektiert}
    if (SelCount = 0) and (SelComponents.Count > 0) then
      Selected[IndexOfObject(SelComponents.Objects[0])] := True;;
  end;
end;

procedure TForm2.FillShortCutBox;
var
  I: Integer;
begin
  with ShortCutBox.Items do
  begin
    Add('Leer');
    for I := Byte('A') to Byte('Z') do Add(ShortCutToText(I or scCtrl));
    for I := VK_F1 to VK_F12 do Add(ShortCutToText(I));
    for I := VK_F1 to VK_F12 do Add(ShortCutToText(I or scCtrl));
    for I := VK_F1 to VK_F12 do Add(ShortCutToText(I or scShift));
    Add(ShortCutToText(VK_INSERT));
    Add(ShortCutToText(VK_INSERT or scCtrl));
    Add(ShortCutToText(VK_INSERT or scShift));
    Add(ShortCutToText(VK_DELETE));
    Add(ShortCutToText(VK_DELETE or scCtrl));
    Add(ShortCutToText(VK_DELETE or scShift));
    Add(ShortCutToText(VK_BACK or scAlt));
    Add(ShortCutToText(VK_BACK or scShift or scAlt));
  end;
end;

end.
